=== tinydict/CMakeLists.txt ===
SET (TINYDICT_SOURCES
    tinydict.cpp
)
ADD_LIBRARY(tinydict STATIC ${TINYDICT_SOURCES})
