=== thirdparty_unman/qimagescale/CMakeLists.txt ===
set(qimagescale_SOURCES
qimagescale.cpp
)

add_library(qimagescale STATIC ${qimagescale_SOURCES})
